<?php /*
CREATE TABLE `url_redirect` (
 `tag` varchar(32) NOT NULL default '''''',
 `url` text NOT NULL,
 `usagecount` int(10) unsigned NOT NULL default '0',
 `description` text NOT NULL,
 PRIMARY KEY  (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 

CREATE TABLE `url_system_vars` (
 `variable` varchar(32) NOT NULL default '',
 `value` varchar(128) NOT NULL default '',
 PRIMARY KEY  (`variable`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1

*/ ?>
<?php require_once('../Connections/HOST.php'); ?>
<?php
$blanktag="Leave blank to autogenerate.";

function GetSQLValueString($theValue, $theType, $theDefinedValue = "", $theNotDefinedValue = "") 
{
  $theValue = (!get_magic_quotes_gpc()) ? addslashes($theValue) : $theValue;

  switch ($theType) {
    case "text":
      $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
      break;    
    case "long":
    case "int":
      $theValue = ($theValue != "") ? intval($theValue) : "NULL";
      break;
    case "double":
      $theValue = ($theValue != "") ? "'" . doubleval($theValue) . "'" : "NULL";
      break;
    case "date":
      $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
      break;
    case "defined":
      $theValue = ($theValue != "") ? $theDefinedValue : $theNotDefinedValue;
      break;
  }
  return $theValue;
}

$editFormAction = $_SERVER['PHP_SELF'];
if (isset($_SERVER['QUERY_STRING'])) {
  $editFormAction .= "?" . htmlentities($_SERVER['QUERY_STRING']);
}

function generate_random($length) {
	$digits = "0123456789abcdefghijklmnopqrstuvwxyz";
	for ($i = 1; $i <= $length; $i++) {
		$retval = $retval . substr($digits, rand(0,35), 1);
		}
	return $retval;
}

function base36reversed($num) {
	$digits = "0123456789abcdefghijklmnopqrstuvwxyz";
	do {
		$retval = $retval . substr($digits, ($num % 36), 1);
		$num    = floor($num / 36);
	} while ($num > 0);
	return $retval;
}

function generate_new_tag($HOST) {
  $Result = mysqli_query($HOST, "SELECT value FROM myst_system_vars WHERE variable='REDIRECT_COUNTER'")
  				or die(mysqli_error());
  if (mysqli_num_rows($Result) <> 1) die("Got wrong # of rows generating tag: " . mysqli_num_rows($Result));

  $row = mysqli_fetch_assoc($Result);
  $next_tag = $row['value'] + 1;
  $Result = mysqli_query($HOST, "UPDATE myst_system_vars SET value='$next_tag' WHERE variable='REDIRECT_COUNTER'") 
  				or die(mysqli_error());
#  return  base36reversed($next_tag) . generate_random(3);
# 4/8/2008: ORIGINALLY ADDED RANDOM DIGITS TO HIDE SEQUENTIALNESS AND PREVENT
# SPOOFING BUT REALISTICALLY, I NEVER USE THESE ADDRESSES PUBLICLY,
# SO I'D RATHER HAVE SHORT LENGTH THAN MIL-SPEC SECURITY :-)

  return  base36reversed($next_tag);
}

function get_existing_tag ($url, $HOST) {
	$existing_url_query = sprintf("SELECT tag FROM myst_redirect WHERE BINARY url = '%s'", $url);
	$existing_url       = mysqli_query($HOST, $existing_url_query) or die(mysqli_error());
	$row                = mysqli_fetch_assoc($existing_url);
	return $row['tag'];
}

if ((isset($_POST["MM_insert"])) && ($_POST["MM_insert"] == "form1")) {
  # mysql_select_db($database_HOST, $HOST);

  $addedTag = $_POST['tag'];
  if ($addedTag == $blanktag || $addedTag == ''):  
	  $addedTag  = get_existing_tag($_POST['url'], $HOST);
	  if (!$addedTag):
		  $addedTag = generate_new_tag($HOST);
		  $insertSQL = sprintf("INSERT INTO myst_redirect (tag, url, description) VALUES ('%s', %s, %s)",
	    	                   /* GetSQLValueString($_POST['tag'], "text"), */
							   $addedTag,
	            	           GetSQLValueString($_POST['url'], "text"),
							   GetSQLValueString($_POST['description'], "text"));

		  $Result1 = mysqli_query($HOST, $insertSQL) or die(mysqli_error());
	  endif;
  else: /* we're supposed to generate a tag */
  	$insertSQL = sprintf("INSERT INTO myst_redirect (tag, url, description) VALUES ('%s', %s, %s)",
							$_POST['tag'], GetSQLValueString($_POST['url'], "text"), 
										   GetSQLValueString($_POST['description'], "text"));

    $Result1 = mysqli_query($HOST, $insertSQL) or die(mysqli_error());
  endif;
  
  header(sprintf("Location: %s", "add.php?addedtag=$addedTag"));
}
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Add a tiny URL</title>
</head>

<body style="background-image:url('https://media.publit.io/file/myst-library-vivid.jpg'); background-size:cover; background-color:#888cd6;">
<h1>MYST.GROUP</h1>
<div style="background-color:rgba(255,255,255,.7); padding:10px; margin:auto 20px auto 20px;">
<form method="post" name="form1" action="<?php echo $editFormAction; ?>">
<?php if (isset($_GET['addedtag'])): 
        $addedtag  = "http://myst.group/"             . $_GET['addedtag'];
?><p>The brief URLs are:</p>
<ul>
<li><a href="<?php echo $addedtag; ?>"><?php echo $addedtag; ?></a></li>
</ul>

<?php endif; ?>
  <table align="center">
    <tr valign="baseline">
      <td nowrap align="right">Tag:</td>
<!--      <td><input type="text" name="tag" size="32" value="<?php echo $blanktag; ?>"></td> -->
      <td><input type="text" name="tag" size="32" value="<?php echo $blanktag; ?>"
                 onfocus="if (this.defaultValue==this.value) this.value=''" 
                 onblur="if (this.value=='') this.value=this.defaultValue"/></td>
    </tr>
    <tr valign="baseline">
      <td nowrap align="right">Url:</td>
      <td><input type="text" name="url" value="" size="32"></td>
    </tr>
    <tr valign="baseline">
      <td nowrap align="right">Description</td>
      <td><textarea name="description" id="description" cols="45" rows="5"></textarea></td>
    </tr>
    <tr valign="baseline">
      <td nowrap align="right">&nbsp;</td>
      <td><input type="submit" value="Insert record"></td>
    </tr>
  </table>
  <input type="hidden" name="MM_insert" value="form1">
</form>
<p><a href="list.php">list</a></p>
</div>
</body>
</html>
